/* my own spooflib with udp only hacked for linux specificness */
#include "humpdee2.h"

#define IP_MF 0x2000

#define IPHDRSIZE sizeof(struct iphdr)
#define UDPHDRSIZE sizeof(struct udphdr)
#define PSEUDOHDRSIZE sizeof(struct pseudoheader)

unsigned char thepacket[2048];

struct pseudoheader{
  struct in_addr src;
  struct in_addr dest;
  unsigned char zero;
  unsigned char protocol;
  unsigned short len;
};

/* standard slow checksum code */
unsigned short in_cksum(addr, len)
    u_short *addr;
    int len;
{
    register int nleft = len;
    register u_short *w = addr;
    register int sum = 0;
    u_short answer = 0;
 
    /*
     * Our algorithm is simple, using a 32 bit accumulator (sum), we add
     * sequential 16 bit words to it, and at the end, fold back all the
     * carry bits from the top 16 bits into the lower 16 bits.
     */
    while (nleft > 1)  {
        sum += *w++;
        nleft -= 2;
    }
 
    /* mop up an odd byte, if necessary */
    if (nleft == 1) {
        *(u_char *)(&answer) = *(u_char *)w ;
        sum += answer;
    }
 
    /* add back carry outs from top 16 bits to low 16 bits */
    sum = (sum >> 16) + (sum & 0xffff); /* add hi 16 to low 16 */
    sum += (sum >> 16);         /* add carry */
    answer = ~sum;              /* truncate to 16 bits */
    return(answer);
}

/* I soon realised that repeating the same code is rather silly */
int buildip(struct in_addr src,struct in_addr dest,
	    unsigned char protocol,unsigned short length,unsigned char *buf,unsigned short off,unsigned short id)
{
struct iphdr *ip;

ip=(struct iphdr *)buf;
bzero(ip,IPHDRSIZE);
ip->version=4;
ip->ihl=5;
ip->tos=0;
ip->tot_len=htons(length);
ip->id=htons(id);
ip->frag_off=htons(off);
ip->ttl=255;
ip->protocol=protocol;
ip->check=0;
ip->saddr=src.s_addr;
ip->daddr=dest.s_addr;
ip->check=in_cksum((u_short *)buf,IPHDRSIZE);
return(1);
}


/* RFC 791 & 768 */
int sendudp(int socket,
             struct in_addr src,unsigned short sport,
             struct in_addr dest,unsigned short dport,
             unsigned short datalen,unsigned char *data)
{
int resu;
unsigned short id;
unsigned short packetlen=0;

struct udphdr *udp;
struct pseudoheader *pseudohdr;
unsigned char *dadata;

struct sockaddr_in servaddr;

pseudohdr=(struct pseudoheader *)(thepacket+IPHDRSIZE-PSEUDOHDRSIZE);
udp=(struct udphdr *)(thepacket+IPHDRSIZE);
dadata=thepacket+IPHDRSIZE+UDPHDRSIZE;

bzero(thepacket,IPHDRSIZE+UDPHDRSIZE+datalen);
memcpy(dadata,data,datalen);

pseudohdr->src=src;
pseudohdr->dest=dest;
pseudohdr->zero=0;
pseudohdr->protocol=17;
pseudohdr->len=htons(UDPHDRSIZE+datalen);

udp->source=htons(sport);
udp->dest=htons(dport);
udp->len=htons(UDPHDRSIZE+datalen);
udp->check=in_cksum((u_short *)pseudohdr,PSEUDOHDRSIZE+UDPHDRSIZE+datalen);


bzero(&servaddr,sizeof(servaddr));
servaddr.sin_family=AF_INET;
servaddr.sin_port=htons(dport);
servaddr.sin_addr=dest;

/* assuming the packetlen > 512 */
packetlen=IPHDRSIZE+UDPHDRSIZE+datalen;
id=rand();
buildip(src,dest,IPPROTO_UDP,packetlen,thepacket,IP_MF,id);
sendto(socket,thepacket,532,0,(struct sockaddr *)&servaddr,sizeof(servaddr));
packetlen-=512;
buildip(src,dest,IPPROTO_UDP,packetlen,thepacket+512,64,id);
resu=sendto(socket,thepacket+512,packetlen,0,(struct sockaddr *)&servaddr,sizeof(servaddr));

return(resu);
}
